unit Question2_U;
//Name and surname:
//Date:
//Question 2
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, DB, ADODB, Grids, DBGrids, StdCtrls, ExtCtrls, Buttons;

type
  TfrmQuestion2 = class(TForm)
    pgcQuestion2: TPageControl;
    tsQuestion21: TTabSheet;
    tsQuestion22: TTabSheet;
    dbgSQL: TDBGrid;
    dbgNGO: TDBGrid;
    dbgVolunteer: TDBGrid;
    btnQ211: TButton;
    btnQ212: TButton;
    btnQ213: TButton;
    btnQ214: TButton;
    btnQ215: TButton;
    btnQ221: TButton;
    btnQ222: TButton;
    btnQ223: TButton;
    chkFullTime: TCheckBox;
    bmbRestore: TBitBtn;
    bmbRestoreDB: TBitBtn;
    edtDomain: TLabeledEdit;
    procedure btnQ211Click(Sender: TObject);
    procedure btnQ212Click(Sender: TObject);
    procedure btnQ213Click(Sender: TObject);
    procedure btnQ214Click(Sender: TObject);
    procedure btnQ215Click(Sender: TObject);
    procedure btnQ221Click(Sender: TObject);
    procedure btnQ222Click(Sender: TObject);
    procedure btnQ223Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure bmbRestoreClick(Sender: TObject);
  private
    procedure Connect;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQuestion2: TfrmQuestion2;
  // Databse will automatically connect
  // These are the two tables that you work with
  tblNGO : TADOTable;
  tblVolunteer : TADOTable;

  // DB SQL component
  qrySQL : TADOQuery;

  //Connection objects
  dsrSQL, dsrNGO, dsrVolunteer : TDataSource;
  dbConnect : TADOConnection;
implementation

{$R *.dfm}

// Question 2.1 - SQL section

// =====================================================
// Question 2.1.1
// =====================================================
procedure TfrmQuestion2.btnQ211Click(Sender: TObject);
var
  sSQL1 : String;
begin
  sSQL1 := '';

  // Provided code - do not change
  qrySQL.SQL.Clear;
  qrySQL.SQL.ADD(sSQL1);
  qrySQL.Open;
end;

// =====================================================
// Question 2.1.2
// =====================================================
procedure TfrmQuestion2.btnQ212Click(Sender: TObject);
var
  sInput : string;
  sSQL2 : String;
begin
  sInput := edtDomain.Text;//Provided code

  sSQL2 := '';

  // Provided code - do not change
  qrySQL.SQL.Clear;
  qrySQL.SQL.ADD(sSQL2);
  qrySQL.Open;
end;

// =====================================================
// Question 2.1.3
// =====================================================
procedure TfrmQuestion2.btnQ213Click(Sender: TObject);
var
  sSQL3 : String;
begin
  sSQL3 := '';

  // Provided code - do not change
  qrySQL.SQL.Clear;
  qrySQL.SQL.ADD(sSQL3);
  qrySQL.Open;
end;

// =====================================================
// Question 2.1.4
// =====================================================
procedure TfrmQuestion2.btnQ214Click(Sender: TObject);
var
  sSQL4 : String;
begin
  sSQL4 := '';

  // Provided code - do not change
  qrySQL.SQL.Clear;
  qrySQL.SQL.ADD(sSQL4);
  qrySQL.Open;
end;

// =====================================================
// Question 2.1.5
// =====================================================
procedure TfrmQuestion2.btnQ215Click(Sender: TObject);
var
  sSQL5 : String;
begin
  sSQL5 := '';

  // Provided code - do not change
  qrySQL.SQL.Clear;
  qrySQL.SQL.ADD(sSQL5);
  qrySQL.ExecSQL;
  ShowMessage('ID 10 has been removed');
end;

// Question 2.2 - Delphi section
procedure TfrmQuestion2.btnQ221Click(Sender: TObject);
begin
  // Question 2.2.1
end;

procedure TfrmQuestion2.btnQ222Click(Sender: TObject);
begin
  // Question 2.2.2
end;


procedure TfrmQuestion2.btnQ223Click(Sender: TObject);
begin
  // Question 2.2.3
end;


//==============================================================================
// Supplied Connection Code - DO NOT CHANGE.
// Database will automatically connect when run
//==============================================================================

procedure TfrmQuestion2.Connect;
begin
  dbConnect := TADOConnection.Create(frmQuestion2);
  dbConnect.Connected := False;
  dbConnect.LoginPrompt := False;

  dbConnect.ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=NGO.mdb;Mode=ReadWrite;Persist Security Info=False;Jet OLEDB:New Database Password="";';

  dbConnect.Provider := 'Provider=Microsoft.Jet.OLEDB.4.0;';
  dbConnect.Open;
  tblNGO := TADOTable.Create(frmQuestion2);
  tblNGO.Connection := dbConnect;
  tblNGO.TableName := 'tblNGO';
  tblNGO.Open;
  dsrNGO := TDataSource.Create(frmQuestion2);
  dsrNGO.DataSet:= tblNGO;
  dbgNGO.DataSource := dsrNGO;

  tblVolunteer := TADOTable.Create(frmQuestion2);
  tblVolunteer.Connection := dbConnect;
  tblVolunteer.TableName := 'tblVolunteers';
  tblVolunteer.Open;
  dsrVolunteer := TDataSource.Create(frmQuestion2);
  dsrVolunteer.DataSet:= tblVolunteer;
  dbgVolunteer.DataSource := dsrVolunteer;

  qrySQL := TADOQuery.Create(frmQuestion2);
  qrySQL.Connection := dbConnect;
  dsrSQL :=  TDataSource.Create(frmQuestion2);
  dsrSQL.DataSet := qrySQL;
  dbgSQL.DataSource := dsrSQL;
end;

procedure TfrmQuestion2.FormActivate(Sender: TObject);
begin
   Connect;
end;

// Supplied Connection Code - DO NOT CHANGE.
procedure TfrmQuestion2.bmbRestoreClick(Sender: TObject);
var
  bFail : Boolean;
begin
  dbConnect.Close;
  dbConnect.Destroy;
  tblNGO.Destroy;
  tblVolunteer.Destroy;
  qrySQL.Destroy;
  DeleteFile('NGO.mdb');
  CopyFile('NGOBackup.mdb','NGO.mdb',bFail);

  Connect;
end;

end.
